#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ReturnBenifitSignCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ReturnBenifitSignCFG> M_ReturnBenifitSignCFG::msSingleton(nullptr);

int M_ReturnBenifitSignCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ReturnBenifitSignCFGData* M_ReturnBenifitSignCFG::GetData(int Day)
{
	auto it = mMapData.find(Day);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ReturnBenifitSignCFGData>& M_ReturnBenifitSignCFG::GetMapData()
{
	return mMapData;
}

void M_ReturnBenifitSignCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ReturnBenifitSignCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ReturnBenifitSignCFGData data;
		data.mDay = element->IntAttribute("Day");
		data.mItem = element->IntAttribute("Item");
		data.mItemCount = element->IntAttribute("ItemCount");
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		assert(mMapData.find(data.mDay) == mMapData.end());
		mMapData.insert(std::make_pair(data.mDay, data));
		element = element->NextSiblingElement();
	}
}

void M_ReturnBenifitSignCFG::Load()
{
	Load("../Config/M_ReturnBenifitSignCFG.xml");
}

M_ReturnBenifitSignCFG* M_ReturnBenifitSignCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ReturnBenifitSignCFG());
	}
	return msSingleton.get();
}
